mscorlib [00 00 00 00 00 00 00 00 04 00 00 00 00 00 00 00] 1.0.5000.0 2.0.0.0 4.0.0.0 Gtk# is thread aware, but not thread safe; See the <link location="node:gtk-sharp/programming/threads">Gtk# Thread Programming</link> for details. System.Security.Cryptography.DeriveBytes System.Runtime.InteropServices.ComVisible(true)

This class uses an extension of the PBKDF1 algorithm defined in the PKCS#5 v2.0 standard to derive bytes suitable for use as key material from a password. The standard is documented in IETF RRC 2898.

Never hard-code a password within your source code. Hard coded passwords can be retrieved from an assembly using the MSIL Disassembler (Ildasm.exe) tool, a hex editor, or by simply opening up the assembly in a text editor like notepad.exe.

Derives a key from a password using an extension of the PBKDF1 algorithm.

- Constructor
  2.0.0.0
  4.0.0.0

  Never hard code a password within your source code. Hard-coded passwords can be retrieved from an assembly using the MSIL Disassembler (Ildasm.exe), a hex editor, or by simply opening up the assembly in a text editor such as Notepad.exe.

  Initializes a new instance of the class specifying the password and key salt to use to derive the key.

  The password to derive the key for.
  The key salt to use to derive the key.
- Constructor
  1.0.5000.0
  2.0.0.0
  4.0.0.0

  Never hard-code a password within your source code. Hard coded passwords can be retrieved from an assembly using the MSIL Disassembler (Ildasm.exe) tool, a hex editor, or by simply opening up the assembly in a text editor like notepad.exe.

  Initializes a new instance of the class with the password and key salt to use to derive the key.

  The password for which to derive the key.
  The key salt to use to derive the key.
- Constructor
  2.0.0.0
  4.0.0.0

  Never hard code a password within your source code. Hard-coded passwords can be retrieved from an assembly using the MSIL Disassembler (Ildasm.exe) l, a hex editor, or by simply opening up the assembly in a text editor such as Notepad.exe.

  Initializes a new instance of the class specifying the password, key salt, and cryptographic service provider (CSP) to use to derive the key.

  The password to derive the key for.
  The key salt to use to derive the key.
  The cryptographic service provider (CSP) parameters for the operation.
- Constructor
  1.0.5000.0
  2.0.0.0
  4.0.0.0

  Never hard-code a password within your source code. Hard coded passwords can be retrieved from an assembly using the MSIL Disassembler (Ildasm.exe) tool, a hex editor, or by simply opening up the assembly in a text editor like notepad.exe.

  Initializes a new instance of the class with the password, key salt, and cryptographic service provider (CSP) parameters to use to derive the key.

  The password for which to derive the key.
  The key salt to use to derive the key.
  The CSP parameters for the operation.
- Constructor
  2.0.0.0
  4.0.0.0

  Never hard code a password within your source code. Hard-coded passwords can be retrieved from an assembly using the MSIL Disassembler (Ildasm.exe), a hex editor, or by simply opening up the assembly in a text editor such as Notepad.exe.

  For a list of hash algorithm names, see the class.

  Initializes a new instance of the class specifying the password, key salt, hash name, and iterations to use to derive the key.

  The password to derive the key for.
  The key salt to use to derive the key.
  The hash algorithm to use to derive the key.
  The iteration count to use to derive the key.
- Constructor
  1.0.5000.0
  2.0.0.0
  4.0.0.0

  Never hard-code a password within your source code. Hard coded passwords can be retrieved from an assembly using the MSIL Disassembler (Ildasm.exe) tool, a hex editor, or by simply opening up the assembly in a text editor like notepad.exe.

  For a list of hash algorithm names, see the class.

  Initializes a new instance of the class with the password, key salt, hash name, and number of iterations to use to derive the key.

  The password for which to derive the key.
  The key salt to use to derive the key.
  The name of the hash algorithm for the operation.
  The number of iterations for the operation.
- Constructor
  2.0.0.0
  4.0.0.0

  Never hard code a password within your source code. Hard-coded passwords can be retrieved from an assembly using the MSIL Disassembler (Ildasm.exe), a hex editor, or by simply opening up the assembly in a text editor such as Notepad.exe.

  For a list of hash algorithm names, see the class.

  Initializes a new instance of the class specifying the password, key salt, hash name, iterations, and cryptographic service provider (CSP) to use to derive the key.

  The password to derive the key for.
  The key salt to use to derive the key.
  The hash algorithm to use to derive the key.
  The iteration count to use to derive the key.
  The cryptographic service provider (CSP) parameters for the operation.
- Constructor
  1.0.5000.0
  2.0.0.0
  4.0.0.0

  Never hard-code a password within your source code. Hard coded passwords can be retrieved from an assembly using the MSIL Disassembler (Ildasm.exe) tool, a hex editor, or by simply opening up the assembly in a text editor like notepad.exe.

  For a list of hash algorithm names, see the class.

  Initializes a new instance of the class with the password, key salt, hash name, number of iterations, and cryptographic service provider (CSP) parameters to use to derive the key.

  The password for which to derive the key.
  The key salt to use to derive the key.
  The name of the hash algorithm for the operation.
  The number of iterations for the operation.
  The CSP parameters for the operation.
- Method
  1.0.5000.0
  2.0.0.0
  4.0.0.0
  System.Byte[] `` `` `` ``

  This function is a wrapper for the Crypto API function CryptDeriveKey(), and is intended to offer interoperability with applications using the Crypto API.

  If the parameter is set to 0 bits, the default key size for the specified algorithm is used.

  Derives a cryptographic key from the object.

  The derived key.

  The algorithm name for which to derive the key. The hash algorithm name to use to derive the key. The size of the key, in bits, to derive. The initialization vector (IV) to use to derive the key.
- Method
  4.0.0.0
  System.Void ``

  This method is called by the public Dispose() method and the Finalize method. Dispose() invokes the protected Dispose(Boolean) method with the parameter set to true. Finalize invokes Dispose with set to false.

  When the parameter is true, this method releases all resources held by any managed objects that this references. This method invokes the Dispose() method of each referenced object.

  Releases the unmanaged resources used by the class and optionally releases the managed resources.

  true to release both managed and unmanaged resources; false to release only unmanaged resources.
- Method
  System.Void To be added Internal state of the algorithm will be zeroized. 1.0.5000.0 2.0.0.0
- Method
  1.0.5000.0
  2.0.0.0
  4.0.0.0
  System.Obsolete("see Rfc2898DeriveBytes for PKCS#5 v2 support")
  System.Byte[] ``

  This method can create any number of pseudo-random bytes. However, the strength of the byte sequence is limited by the number of bytes in the hash output.

  Returns pseudo-random key bytes.

  A byte array filled with pseudo-random key bytes.

  The number of pseudo-random key bytes to generate.
- Property
  1.0.5000.0
  2.0.0.0
  4.0.0.0
  System.String The current hash algorithm used to derive bytes. Default hash algorithm is and can provide, securely, up to 20 bytes of data.

  Gets or sets the name of the hash algorithm for the operation.

- Property
  1.0.5000.0
  2.0.0.0
  4.0.0.0
  System.Int32 The current iteration count.

  This value can be ajusted to a balance so deriving a single key from a password is relatively fast (normal use) but very slow to use multiple times (e.g. attackers using a dictionary or a brute force attack). This makes the derivation algorithm stays "current" with newer and faster computer.

  Interoperability warning: The default iteration count is 1 to be compatible with Microsoft implementation. However this value is too low to be secure. Many other implementations use 1000 or 1024.

  Gets or sets the number of iterations for the operation.

- Method
  1.0.5000.0
  2.0.0.0
  4.0.0.0
  System.Void The next call to GetBytes will be identical to the first call.

  Resets the state of the operation.

- Property
  1.0.5000.0
  2.0.0.0
  4.0.0.0
  System.Byte[] The current salt value being used to derive bytes.

  A dictionary attack is an attack in which the attacker attempts to decrypt an encrypted message by comparing the encrypted value with previously computed encrypted values for the most likely keys. This attack is made much more difficult by the introduction of random bytes at the end of the password before the key derivation. These random bytes are known as salt.

  Gets or sets the key salt value for the operation.